/****************************************************************************
** Form interface generated from reading ui file 'src/qsynthMainForm.ui'
**
** Created: Tue Jul 25 15:04:17 2006
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.4   edited Nov 24 2003 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef QSYNTHMAINFORM_H
#define QSYNTHMAINFORM_H

#include <qvariant.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qsettings.h>
#include <qsocketnotifier.h>
#include <qpopupmenu.h>
#include "qsynthEngine.h"
#include "qsynthMessagesForm.h"
#include "qsynthChannelsForm.h"
#include "qsynthTabBar.h"
#include "qsynthSystemTray.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class qsynthTabBar;
class qsynthMeter;
class qsynthKnob;
class QFrame;
class QPushButton;
class QGroupBox;
class QSpinBox;
class QLabel;
class QCheckBox;
class QComboBox;

class qsynthMainForm : public QWidget
{
    Q_OBJECT

public:
    qsynthMainForm( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~qsynthMainForm();

    QFrame* InstanceFrame;
    QPushButton* RestartPushButton;
    QPushButton* SystemResetPushButton;
    QPushButton* ProgramResetPushButton;
    QPushButton* ChannelsPushButton;
    QGroupBox* ReverbGroupBox;
    qsynthKnob* ReverbDampDial;
    QSpinBox* ReverbDampSpinBox;
    QLabel* ReverbDampTextLabel;
    qsynthKnob* ReverbRoomDial;
    QSpinBox* ReverbRoomSpinBox;
    QLabel* ReverbRoomTextLabel;
    qsynthKnob* ReverbWidthDial;
    QSpinBox* ReverbWidthSpinBox;
    QLabel* ReverbWidthTextLabel;
    qsynthKnob* ReverbLevelDial;
    QSpinBox* ReverbLevelSpinBox;
    QLabel* ReverbLevelTextLabel;
    QCheckBox* ReverbActiveCheckBox;
    QGroupBox* GainGroupBox;
    QSpinBox* GainSpinBox;
    QLabel* GainTextLabel;
    qsynthKnob* GainDial;
    QPushButton* SetupPushButton;
    QGroupBox* ChorusGroupBox;
    qsynthKnob* ChorusLevelDial;
    QSpinBox* ChorusLevelSpinBox;
    QLabel* ChorusLevelTextLabel;
    qsynthKnob* ChorusSpeedDial;
    QSpinBox* ChorusSpeedSpinBox;
    QLabel* ChorusSpeedTextLabel;
    qsynthKnob* ChorusNrDial;
    QSpinBox* ChorusNrSpinBox;
    QLabel* ChorusNrTextLabel;
    qsynthKnob* ChorusDepthDial;
    QSpinBox* ChorusDepthSpinBox;
    QLabel* ChorusDepthTextLabel;
    QCheckBox* ChorusActiveCheckBox;
    QLabel* ChorusTypeTextLabel;
    QComboBox* ChorusTypeComboBox;
    QGroupBox* OutputGroupBox;
    qsynthMeter* OutputMeter;
    QFrame* RightButtonFrame;
    QPushButton* QuitPushButton;
    QPushButton* OptionsPushButton;
    QPushButton* MessagesPushButton;
    QPushButton* AboutPushButton;
    QPushButton* NewEnginePushButton;
    qsynthTabBar* TabBar;
    QPushButton* DeleteEnginePushButton;

    void setup( qsynthOptions *pOptions );
    void appendMessages( const QString & s );
    void appendMessagesColor( const QString & s, const QString & c );
    void appendMessagesText( const QString & s );
    void appendMessagesError( const QString & s );
    bool deleteEngineTab( qsynthEngine *pEngine, qsynthTab *pTab );
    bool setupEngineTab( qsynthEngine *pEngine, qsynthTab *pTab );
    bool startEngine( qsynthEngine *pEngine );
    void stopEngine( qsynthEngine *pEngine );
    void restartAllEngines( void );
    void restartEngine( qsynthEngine *pEngine );
    void resetEngine( qsynthEngine *pEngine );

public slots:
    void stdoutNotifySlot( int fd );
    void appendStdoutBuffer( const QString & s );
    void flushStdoutBuffer( void );
    void systemTrayContextMenu( const QPoint & pos );
    void stabilizeForm( void );
    void programReset();
    void systemReset();
    void promptRestart();
    void newEngine( void );
    void deleteEngine( void );
    void toggleMainForm( void );
    void toggleMessagesForm( void );
    void toggleChannelsForm( void );
    void showSetupForm( void );
    void showOptionsForm( void );
    void showAboutForm( void );
    void tabSelect( int iTab );
    void tabContextMenu( qsynthTab *pTab, const QPoint & pos );
    void timerSlot( void );
    void reverbActivate( bool bActive );
    void chorusActivate( bool bActive );
    void gainChanged( int );
    void reverbChanged( int );
    void chorusChanged( int );
    void activateEnginesMenu ( int iItemID );
    void quitMainForm( void );

protected:
    QGridLayout* qsynthMainFormLayout;
    QGridLayout* InstanceFrameLayout;
    QVBoxLayout* InstanceToolsLayout;
    QGridLayout* ReverbGroupBoxLayout;
    QGridLayout* ReverbDampLayout;
    QGridLayout* ReverbRoomLayout;
    QGridLayout* ReverbWidthLayout;
    QGridLayout* ReverbLevelLayout;
    QGridLayout* GainGroupBoxLayout;
    QGridLayout* GainMasterLayout;
    QGridLayout* ChorusGroupBoxLayout;
    QGridLayout* ChorusLevelLayout;
    QGridLayout* ChorusSpeedLayout;
    QGridLayout* ChorusNrLayout;
    QGridLayout* ChorusDepthLayout;
    QHBoxLayout* ChorusTypeLayout;
    QVBoxLayout* OutputGroupBoxLayout;
    QVBoxLayout* RightButtonFrameLayout;
    QSpacerItem* spacer1;
    QHBoxLayout* TabBarLayout;

protected slots:
    virtual void languageChange();

private:
    qsynthOptions *m_pOptions;
    int m_iTimerDelay;
    int m_iCurrentTab;
    QSocketNotifier *m_pStdoutNotifier;
    qsynthMessagesForm *m_pMessagesForm;
    qsynthChannelsForm *m_pChannelsForm;
    int m_iGainChanged;
    int m_iReverbChanged;
    int m_iChorusChanged;
    int m_iGainUpdated;
    int m_iReverbUpdated;
    int m_iChorusUpdated;
    QString m_sStdoutBuffer;
    int m_iSystemTrayState;
    qsynthSystemTray *m_pSystemTray;
    QPopupMenu *m_pEnginesMenu;
    bool m_bQuitForce;

    QPixmap image0;

    void init();
    void destroy();
    bool queryClose( void );
    void closeEvent( QCloseEvent *pCloseEvent );
    void playLoadFiles ( qsynthEngine *pEngine, const QStringList & files, bool bSetup );
    bool decodeDragFiles( const QMimeSource * pEvent, QStringList & files );
    void dragEnterEvent( QDragEnterEvent *pDragEnterEvent );
    void dropEvent( QDropEvent *pDropEvent );
    void updateMessagesFont( void );
    void updateMessagesLimit( void );
    void updateOutputMeters( void );
    void updateSystemTray( void );
    qsynthEngine * currentEngine( void );
    void setEngineGain( qsynthEngine *pEngine, float fGain );
    void setEngineReverbOn( qsynthEngine *pEngine, bool bActive );
    void setEngineReverb( qsynthEngine *pEngine, float fRoom, float fDamp, float fWidth, float fLevel );
    void setEngineChorusOn( qsynthEngine *pEngine, bool bActive );
    void setEngineChorus( qsynthEngine *pEngine, int iNr, float fLevel, float fSpeed, float fDepth, int iType );
    void loadPanelSettings( qsynthEngine *pEngine, bool bUpdate );
    void savePanelSettings( qsynthEngine *pEngine );
    void resetChannelsForm( qsynthEngine *pEngine, bool fPreset );
    void updateGain( void );
    void updateReverb( void );
    void updateChorus( void );
    void refreshGain( void );
    void refreshReverb( void );
    void refreshChorus( void );
    void contextMenuEvent( QContextMenuEvent *pEvent );

};

#endif // QSYNTHMAINFORM_H
